// Copyright (c) 2014 AlphaSierraPapa for the SharpDevelop Team
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this
// software and associated documentation files (the "Software"), to deal in the Software
// without restriction, including without limitation the rights to use, copy, modify, merge,
// publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
// to whom the Software is furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in all copies or
// substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
// INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
// PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
// FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.

using System;

namespace ICSharpCode.Decompiler.Tests.TestCases.Correctness
{
	/// <summary>
	/// Description of DecimalFields.
	/// </summary>
	public class DecimalFields
	{
		public const decimal field1 = 1.5m;
		public const decimal field2 = decimal.One;
		public const decimal field3 = decimal.MaxValue;
		public const decimal field4 = decimal.MinValue;

		public static int Main()
		{
			Console.WriteLine(field1);
			Console.WriteLine(field2);
			Console.WriteLine(field3);
			Console.WriteLine(field4);
			Console.WriteLine(IntToDecimal());
			Console.WriteLine(UIntToDecimal());
			Console.WriteLine(LongToDecimal());
			Console.WriteLine(ULongToDecimal());
			return 0;
		}

		public static decimal IntToDecimal()
		{
			return (decimal)int.MaxValue;
		}

		public static decimal UIntToDecimal()
		{
			return (decimal)uint.MaxValue;
		}

		public static decimal LongToDecimal()
		{
			return (decimal)long.MaxValue;
		}

		public static decimal ULongToDecimal()
		{
			return (decimal)ulong.MaxValue;
		}
	}
}
